/*
 * Client functionality for keypad library access.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/devices/dl.h>
#include "keypad.h"
#include "keypad-loader.h"

Keypad *load_keypad()
{
  // Load the keypad library using details in the specified file.

  void *(*keypad_get)(void);

  keypad_get = (void *(*)(void)) load_function("rom/input-keypad.txt", "keypad_get");
  if (!keypad_get) return 0;

  // Return the keypad details.

  return (Keypad *) keypad_get();
}
